'===========
'TriPegs.Bas
'===========
'A clone of crakle barrels wooden peg game
'Coded in QB64 by Dav, MAY/2022

'Using mouse, jump over pegs.
'Leave only one peg to win game.

'Space resets board, starts over.

'NOTE: You need the tripegs-data folder and all of its files!

'===========================================================


$EXEICON:'.\tripegs.ico'
_ICON

'Peg hole values
DIM SHARED pegs: pegs = 15
DIM SHARED px(pegs), py(pegs), peg&, board&, peg2&
DIM SHARED hx(pegs), hy(pegs), hx2(pegs), hy2(pegs), hv(pegs)

hx(1) = 347: hy(1) = 72: hx(2) = 286: hy(2) = 169
hx(3) = 391: hy(3) = 165: hx(4) = 226: hy(4) = 263
hx(5) = 338: hy(5) = 267: hx(6) = 448: hy(6) = 263
hx(7) = 168: hy(7) = 372: hx(8) = 284: hy(8) = 367
hx(9) = 411: hy(9) = 368: hx(10) = 505: hy(10) = 365
hx(11) = 106: hy(11) = 470: hx(12) = 218: hy(12) = 465
hx(13) = 354: hy(13) = 460: hx(14) = 463: hy(14) = 463
hx(15) = 554: hy(15) = 468
FOR t = 1 TO pegs
    hx2(t) = hx(t) + 40: hy2(t) = hy(t) + 40
    px(t) = hx(t) - 7: py(t) = hy(t)
NEXT

SCREEN _LOADIMAGE("tripegs-data\board4.jpg", 32)
DO: LOOP UNTIL _SCREENEXISTS: _TITLE "tripegs"

board& = _LOADIMAGE("tripegs-data\board4.jpg", 32)
peg& = _LOADIMAGE("tripegs-data\pegb.png")
peg2& = _LOADIMAGE("tripegs-data\peg2b.png")
pegup& = _SNDOPEN("tripegs-data\pegup.wav")
pegdown& = _SNDOPEN("tripegs-data\pegdown.wav")


'=============
NEWGAME:
'=============

_AUTODISPLAY: _PUTIMAGE (0, 0), board&

'reset hole values
FOR t = 1 TO pegs: hv(t) = 1: NEXT
'Make one random hole empty
RANDOMIZE TIMER: hv(INT(RND * 15) + 1) = 0

'draw pegs on board
FOR P = 1 TO pegs
    DrawPeg (P)
NEXT

DO
    t = _MOUSEINPUT

    IF _MOUSEBUTTON(1) THEN
        mx = _MOUSEX: my = _MOUSEY
        'see if user clicked a peg hole area
        FOR t = 1 TO pegs
            mx = _MOUSEX: my = _MOUSEY
            IF mx >= hx(t) AND mx <= hx2(t) AND my >= hy(t) AND my <= hy2(t) THEN
                'only pick up if hole occupied with peg
                IF hv(t) = 1 THEN
                    _SNDPLAY pegup&
                    PegInHand = t
                    hv(t) = 0 'mark this peg hole empty while peg in hand
                    'redraw board
                    _PUTIMAGE (0, 0), board&
                    FOR P = 1 TO pegs: DrawPeg (P): NEXT
                    'now grab current screen image (minus selected peg)
                    back& = _COPYIMAGE(_DISPLAY)

                    'get users dropping of peg
                    DO
                        'show selected peg in hand, over background
                        'below makes it only show every once in a while
                        '(this speeds up display on slower machines)
                        IF INT(RND * 4) = 1 THEN
                            _PUTIMAGE (0, 0), back&
                            _PUTIMAGE (_MOUSEX - 25, _MOUSEY - 20), peg2&: _DISPLAY
                        END IF
                        'If user unclicked the button
                        t2 = _MOUSEINPUT
                        IF _MOUSEBUTTON(1) = 0 THEN
                            mx2 = _MOUSEX: my2 = _MOUSEY
                            'see if unclicked over a hole
                            FOR r = 1 TO pegs
                                IF mx2 >= hx(r) - 20 AND mx2 <= hx2(r) + 20 AND my2 >= hy(r) - 15 AND my2 <= hy2(r) + 15 THEN
                                    'If the hole was empty...
                                    IF hv(r) = 0 THEN
                                        'check if it's a valid move
                                        IF ValidMove(PegInHand, r) = 1 THEN
                                            'If so, then place it...
                                            hv(r) = 1 'mark hole as now pegged
                                            hv(PegInHand) = 0
                                            'Play a drop sound
                                            _SNDPLAY pegdown&
                                        ELSE
                                            'Nope, Replace peg
                                            hv(PegInHand) = 1
                                            GOSUB PegReturn
                                        END IF
                                    ELSE
                                        hv(PegInHand) = 1
                                        GOSUB PegReturn
                                    END IF

                                    GOTO doneamove

                                END IF
                            NEXT
                            hv(PegInHand) = 1 'Return peg to original
                            GOSUB PegReturn

                            GOTO doneamove

                        END IF
                    LOOP

                END IF

            END IF
        NEXT

        doneamove:

        _PUTIMAGE (0, 0), board&
        FOR u = 1 TO pegs: DrawPeg (u): NEXT
        _DISPLAY

    END IF

    IF INKEY$ = CHR$(32) THEN GOTO NEWGAME

LOOP UNTIL MovesLeft = 0


'Game over, so...See How many pegs left on board
C = 0
FOR s = 1 TO pegs
    IF hv(s) = 1 THEN C = C + 1
NEXT

'Show message based on peg number

SELECT CASE C
    CASE IS = 1: msg& = _LOADIMAGE("tripegs-data\genius.png")
    CASE IS = 2: msg& = _LOADIMAGE("tripegs-data\smart.png")
    CASE IS = 3: msg& = _LOADIMAGE("tripegs-data\dumb.png")
    CASE ELSE: msg& = _LOADIMAGE("tripegs-data\egnoramoose.png")
END SELECT

_PUTIMAGE (170, 200), msg&: _DISPLAY
_FREEIMAGE msg&

_DELAY 2

GOTO NEWGAME

END


'=================================================================

PegReturn:

'animate sending peg back to hole
cx = mx2: cy = my2
xdone = 0: ydone = 0
DO
    IF mx2 > mx THEN
        cx = cx - 12
        IF cx < mx THEN
            cx = mx: xdone = 1
        END IF
    ELSE
        cx = cx + 12
        IF cx > mx THEN
            cx = mx: xdone = 1
        END IF
    END IF

    IF my2 > my THEN
        cy = cy - 12
        IF cy < my THEN
            cy = my: ydone = 1
        END IF
    ELSE
        cy = cy + 12
        IF cy > my THEN
            cy = my: ydone = 1
        END IF

    END IF

    _PUTIMAGE (0, 0), back&
    _PUTIMAGE (cx - 20, cy - 20), peg2&: _DISPLAY

    _DELAY .0075

LOOP UNTIL xdone = 1 AND ydone = 1

RETURN


'==================================================

SUB DrawPeg (num)
    IF hv(num) = 1 THEN
        _PUTIMAGE (px(num), py(num)), peg&
    END IF
END SUB

'==================================================

FUNCTION ValidMove% (num1, num2)

    '====== logic for hole 1
    IF num1 = 1 THEN
        IF num2 = 4 THEN
            IF hv(2) = 1 THEN
                hv(1) = 0: hv(2) = 0: hv(4) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 6 THEN
            IF hv(3) = 1 THEN
                hv(1) = 0: hv(3) = 0: hv(6) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 2
    IF num1 = 2 THEN
        IF num2 = 7 THEN
            IF hv(4) = 1 THEN
                hv(2) = 0: hv(4) = 0: hv(7) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 9 THEN
            IF hv(5) = 1 THEN
                hv(2) = 0: hv(5) = 0: hv(9) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 3
    IF num1 = 3 THEN
        IF num2 = 8 THEN
            IF hv(5) = 1 THEN
                hv(3) = 0: hv(5) = 0: hv(8) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 10 THEN
            IF hv(6) = 1 THEN
                hv(3) = 0: hv(6) = 0: hv(10) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 4
    IF num1 = 4 THEN
        IF num2 = 1 THEN
            IF hv(2) = 1 THEN
                hv(4) = 0: hv(2) = 0: hv(1) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 6 THEN
            IF hv(5) = 1 THEN
                hv(4) = 0: hv(5) = 0: hv(6) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 13 THEN
            IF hv(8) = 1 THEN
                hv(4) = 0: hv(8) = 0: hv(13) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 11 THEN
            IF hv(7) = 1 THEN
                hv(4) = 0: hv(7) = 0: hv(11) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 5
    IF num1 = 5 THEN
        IF num2 = 12 THEN
            IF hv(8) = 1 THEN
                hv(5) = 0: hv(8) = 0: hv(12) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 14 THEN
            IF hv(9) = 1 THEN
                hv(5) = 0: hv(9) = 0: hv(14) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 6
    IF num1 = 6 THEN
        IF num2 = 1 THEN
            IF hv(3) = 1 THEN
                hv(6) = 0: hv(3) = 0: hv(1) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 4 THEN
            IF hv(5) = 1 THEN
                hv(6) = 0: hv(5) = 0: hv(4) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 13 THEN
            IF hv(9) = 1 THEN
                hv(6) = 0: hv(9) = 0: hv(13) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 15 THEN
            IF hv(10) = 1 THEN
                hv(6) = 0: hv(10) = 0: hv(15) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 7
    IF num1 = 7 THEN
        IF num2 = 2 THEN
            IF hv(4) = 1 THEN
                hv(7) = 0: hv(4) = 0: hv(2) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 9 THEN
            IF hv(8) = 1 THEN
                hv(7) = 0: hv(8) = 0: hv(9) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 8
    IF num1 = 8 THEN
        IF num2 = 3 THEN
            IF hv(5) = 1 THEN
                hv(8) = 0: hv(5) = 0: hv(3) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 10 THEN
            IF hv(9) = 1 THEN
                hv(8) = 0: hv(9) = 0: hv(10) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 9
    IF num1 = 9 THEN
        IF num2 = 2 THEN
            IF hv(5) = 1 THEN
                hv(9) = 0: hv(5) = 0: hv(2) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 7 THEN
            IF hv(8) = 1 THEN
                hv(9) = 0: hv(8) = 0: hv(7) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 10
    IF num1 = 10 THEN
        IF num2 = 8 THEN
            IF hv(9) = 1 THEN
                hv(10) = 0: hv(9) = 0: hv(8) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 3 THEN
            IF hv(6) = 1 THEN
                hv(10) = 0: hv(6) = 0: hv(3) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 11
    IF num1 = 11 THEN
        IF num2 = 4 THEN
            IF hv(7) = 1 THEN
                hv(11) = 0: hv(7) = 0: hv(4) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 13 THEN
            IF hv(12) = 1 THEN
                hv(11) = 0: hv(12) = 0: hv(13) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 12
    IF num1 = 12 THEN
        IF num2 = 5 THEN
            IF hv(8) = 1 THEN
                hv(12) = 0: hv(8) = 0: hv(5) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 14 THEN
            IF hv(13) = 1 THEN
                hv(12) = 0: hv(13) = 0: hv(14) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 13
    IF num1 = 13 THEN
        IF num2 = 4 THEN
            IF hv(8) = 1 THEN
                hv(13) = 0: hv(8) = 0: hv(4) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 6 THEN
            IF hv(9) = 1 THEN
                hv(13) = 0: hv(9) = 0: hv(6) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 11 THEN
            IF hv(12) = 1 THEN
                hv(13) = 0: hv(12) = 0: hv(11) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 15 THEN
            IF hv(14) = 1 THEN
                hv(13) = 0: hv(14) = 0: hv(15) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 14
    IF num1 = 14 THEN
        IF num2 = 5 THEN
            IF hv(9) = 1 THEN
                hv(14) = 0: hv(9) = 0: hv(5) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 12 THEN
            IF hv(13) = 1 THEN
                hv(14) = 0: hv(13) = 0: hv(12) = 1: ValidMove = 1
            END IF
        END IF
    END IF

    '====== logic for hole 15
    IF num1 = 15 THEN
        IF num2 = 6 THEN
            IF hv(10) = 1 THEN
                hv(15) = 0: hv(10) = 0: hv(6) = 1: ValidMove = 1
            END IF
        END IF
        IF num2 = 13 THEN
            IF hv(14) = 1 THEN
                hv(15) = 0: hv(14) = 0: hv(13) = 1: ValidMove = 1
            END IF
        END IF
    END IF

END FUNCTION

'=============================================================

FUNCTION MovesLeft
    'returns 1 if any moves left on board

    m = 0 'default to no moves left

    'btn 1
    IF hv(1) = 1 AND hv(2) = 1 AND hv(4) = 0 THEN m = 1
    IF hv(1) = 1 AND hv(3) = 1 AND hv(6) = 0 THEN m = 1
    'btn2
    IF hv(2) = 1 AND hv(4) = 1 AND hv(7) = 0 THEN m = 1
    IF hv(2) = 1 AND hv(5) = 1 AND hv(9) = 0 THEN m = 1
    'btn 3
    IF hv(3) = 1 AND hv(5) = 1 AND hv(8) = 0 THEN m = 1
    IF hv(3) = 1 AND hv(6) = 1 AND hv(10) = 0 THEN m = 1
    'btn 4
    IF hv(4) = 1 AND hv(2) = 1 AND hv(1) = 0 THEN m = 1
    IF hv(4) = 1 AND hv(5) = 1 AND hv(6) = 0 THEN m = 1
    IF hv(4) = 1 AND hv(7) = 1 AND hv(11) = 0 THEN m = 1
    IF hv(4) = 1 AND hv(8) = 1 AND hv(13) = 0 THEN m = 1
    'btn 5
    IF hv(5) = 1 AND hv(8) = 1 AND hv(12) = 0 THEN m = 1
    IF hv(5) = 1 AND hv(9) = 1 AND hv(14) = 0 THEN m = 1
    'btn 6
    IF hv(6) = 1 AND hv(3) = 1 AND hv(1) = 0 THEN m = 1
    IF hv(6) = 1 AND hv(9) = 1 AND hv(13) = 0 THEN m = 1
    IF hv(6) = 1 AND hv(5) = 1 AND hv(4) = 0 THEN m = 1
    IF hv(6) = 1 AND hv(10) = 1 AND hv(15) = 0 THEN m = 1
    'btn 7
    IF hv(7) = 1 AND hv(4) = 1 AND hv(2) = 0 THEN m = 1
    IF hv(7) = 1 AND hv(8) = 1 AND hv(9) = 0 THEN m = 1
    'btn 8
    IF hv(8) = 1 AND hv(5) = 1 AND hv(3) = 0 THEN m = 1
    IF hv(8) = 1 AND hv(9) = 1 AND hv(10) = 0 THEN m = 1
    'btn 9
    IF hv(9) = 1 AND hv(5) = 1 AND hv(2) = 0 THEN m = 1
    IF hv(9) = 1 AND hv(8) = 1 AND hv(7) = 0 THEN m = 1
    'btn 10
    IF hv(10) = 1 AND hv(9) = 1 AND hv(8) = 0 THEN m = 1
    IF hv(10) = 1 AND hv(6) = 1 AND hv(3) = 0 THEN m = 1
    'btn 11
    IF hv(11) = 1 AND hv(7) = 1 AND hv(4) = 0 THEN m = 1
    IF hv(11) = 1 AND hv(12) = 1 AND hv(13) = 0 THEN m = 1
    'btn 12
    IF hv(12) = 1 AND hv(8) = 1 AND hv(5) = 0 THEN m = 1
    IF hv(12) = 1 AND hv(13) = 1 AND hv(14) = 0 THEN m = 1
    'btn 13
    IF hv(13) = 1 AND hv(8) = 1 AND hv(4) = 0 THEN m = 1
    IF hv(13) = 1 AND hv(9) = 1 AND hv(6) = 0 THEN m = 1
    IF hv(13) = 1 AND hv(14) = 1 AND hv(15) = 0 THEN m = 1
    IF hv(13) = 1 AND hv(12) = 1 AND hv(11) = 0 THEN m = 1
    'btn 14
    IF hv(14) = 1 AND hv(9) = 1 AND hv(5) = 0 THEN m = 1
    IF hv(14) = 1 AND hv(13) = 1 AND hv(12) = 0 THEN m = 1
    'btn 15
    IF hv(15) = 1 AND hv(10) = 1 AND hv(6) = 0 THEN m = 1
    IF hv(15) = 1 AND hv(14) = 1 AND hv(13) = 0 THEN m = 1

    MovesLeft = m
END FUNCTION


